using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Serial2SendKeys
{

    delegate void StringDataDelegate(String msg);

    public partial class Serial2SendKeys : Form
    {
        public Serial2SendKeys()
        {
            InitializeComponent();

            serialPort.NewLine = "\r\n"; // sR[h

            // PortName init
            for (int i = 1; i <= 255; i++) // R{{bNXɃACeǉ
            {
                comboBoxSerialPort.Items.Add("COM" + i);
            }
            comboBoxSerialPort.SelectedIndex = 0;

            // BaudRate init
            for (int i = 300; i <= 76800; i *= 2)
            {
                comboBoxSerialBaud.Items.Add(i);
            }
            comboBoxSerialBaud.SelectedIndex = 5;

        }

        private void buttonSerialConnect_Click(object sender, EventArgs e)
        {
            if (!serialPort.IsOpen) // ĂJ
            {
                serialPort.PortName = comboBoxSerialPort.SelectedItem.ToString();
                serialPort.BaudRate = Int32.Parse(comboBoxSerialBaud.SelectedItem.ToString());
                try
                {
                    serialPort.Open();
                    comboBoxSerialPort.Enabled = false;
                    comboBoxSerialBaud.Enabled = false;
                    buttonSerialConnect.Text = "Close";
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.ToString());
                }
            }
            else // JĂ
            {
                try
                {
                    serialPort.Close();
                    comboBoxSerialPort.Enabled = true;
                    comboBoxSerialBaud.Enabled = true;
                    buttonSerialConnect.Text = "Connect";
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.ToString());
                }
            }
        }

        private void serialPort_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            StringDataDelegate strDel = TextBox_write;
            strDel += SendKeys.Send;
            try
            {
                String recvData = serialPort.ReadLine();
                Invoke(strDel, recvData);
                SendKeys.Send(recvData);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
                
        }

        /// <summary>
        /// write(string)DelegateoRŌĂ΂
        /// </summary>
        /// <param name="str">Trace\镶</param>
        private void TextBox_write(string str)
        {
            textBoxRecv.Text = str;
        }

    }
}