using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SerialPortTest
{
    delegate void StringDataDelegate(String msg);

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            // PortName init
            for (int i = 1; i <= 100; i++) // R{{bNXɃACeǉ
            {
                comboBoxSerialPort.Items.Add("COM" + i);
            }
            comboBoxSerialPort.SelectedIndex = 0;

            // BaudRate init
            for (int i = 300; i <= 76800; i *= 2)
            {
                comboBoxSerialBaud.Items.Add(i);
            }
            comboBoxSerialBaud.SelectedIndex = 5;


            serialPort.NewLine = "\n"; // sL
        }


        /// <summary>
        /// VA|[gڑ/ؒf{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonSerialConnect_Click(object sender, EventArgs e)
        {
            if (!serialPort.IsOpen) // ĂJ
            {
                serialPort.PortName = comboBoxSerialPort.SelectedItem.ToString();
                serialPort.BaudRate = Int32.Parse(comboBoxSerialBaud.SelectedItem.ToString());
                try
                {
                    serialPort.Open();
                    comboBoxSerialPort.Enabled = false;
                    comboBoxSerialBaud.Enabled = false;
                    buttonSerialSend.Enabled = true;
                    textBoxSend.Enabled = true;
                    buttonSerialConnect.Text = "Close";
                }
                catch
                {
                    Console.WriteLine("SerialPort Open error");
                }
            }
            else // JĂ
            {
                try
                {
                    serialPort.Close();
                    comboBoxSerialPort.Enabled = true;
                    comboBoxSerialBaud.Enabled = true;
                    buttonSerialSend.Enabled = false;
                    textBoxSend.Enabled = false;
                    buttonSerialConnect.Text = "Connect";
                }
                catch
                {
                    Console.WriteLine("SerialPort Close error");
                }
            }
        }

        /// <summary>
        /// MTextBoxɂ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonTextBoxClear_Click(object sender, EventArgs e)
        {
            textBoxRecv.Text = "";
        }


        /// <summary>
        /// VA|[gM{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonSerialSend_Click(object sender, EventArgs e)
        {
            if (serialPort.IsOpen)
            {
                try
                {
                    serialPort.WriteLine(textBoxSend.Text);
                    textBoxSend.Text = "";
                }
                catch
                {
                    Console.WriteLine("SerialPort DataSending error");
                }
            }
        }

        /// <summary>
        /// VA|[gf[^M
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void serialPort_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            try
            {
                String recvData = serialPort.ReadLine(); // 1sǂ
                if (recvData != null)
                {
                    Console.WriteLine("recv: "+recvData);
                    StringDataDelegate traceDelegate = TextBox_write;
                    Invoke(traceDelegate, recvData);
                }
            }
            catch
            {
                Console.WriteLine("SerialPort DataReceiving error");
            }
        }


        /// <summary>
        /// write(string)DelegateoRŌĂ΂
        /// </summary>
        /// <param name="str">Trace\镶</param>
        private void TextBox_write(string str)
        {
            textBoxRecv.Text = str + "\r\n" + textBoxRecv.Text;
        }

    }
}